//  MTGCommon.mm
//  Cocos2dxSample-mobile
//
//  Created by YM on 2018/05/16.
//

#include "MTGCommon.h"
#import "../MTGAdUtility.h"
#import <MTGSDK/MTGSDK.h>

using namespace std;
using namespace cn::mtgsdk;

CommonResultEvent onadsLoadedBlock;

NSString* convertToNSString3(string string)
{
    return [NSString stringWithUTF8String:string.c_str()];
}

void MTGCommon::initMintegralSDK(string appid,string apikey){
    if (![MTGAdUtility isSDKInitialized]) {
        //init Mobvista Ads
        [[MTGSDK sharedInstance] setAppID:convertToNSString3(appid) ApiKey:convertToNSString3(apikey)];
        [MTGAdUtility sdkInitialized];
    }
}

void MTGCommon::addCallbackCommonAd(CommonResultEvent callback)
{
    if (callback)
    {
        onadsLoadedBlock = callback;
    }
}

void MTGCommon::showUserPrivateInfoTips()
{
    [[MTGSDK sharedInstance] showUserPrivateInfoTips:^(MTGUserPrivateTypeInfo *userPrivateTypeInfo, NSError *error) {
        if (error == nil) {
            
            NSString * info = [NSString stringWithFormat: @"isGeneralDataAllowed = %d ,isDeviceIdAllowed = %d ,isGpsAllowed = %d",userPrivateTypeInfo.isGeneralDataAllowed,userPrivateTypeInfo.isDeviceIdAllowed,userPrivateTypeInfo.isGpsAllowed];
            NSLog(@"%@", info);
            
            onadsLoadedBlock("onShowUserInfoTips", "YES");
        }else{
            NSLog(@"%@", error.localizedDescription);
            printPrivateInfoStatus ();
            
            onadsLoadedBlock("onShowUserInfoTips", "NO");
        }
    }];
    
}

void MTGCommon::setUserPrivateInfoType(string statusKey,string  statusType)
{
    NSString *statusKeyStr = convertToNSString3(statusKey);
    NSString *statusTypeStr = convertToNSString3(statusType);
    BOOL isSet = NO;
    
    if([statusTypeStr isEqualToString:@"ON"]){
        isSet = YES;
    }else{
        isSet = NO;
    }
    
    
    if([statusKeyStr isEqualToString:@"authority_all_info"]){
        [[MTGSDK sharedInstance] setUserPrivateInfoType:MTGUserPrivateType_ALL agree:isSet];
        
    }else if([statusKeyStr isEqualToString:@"authority_general_data"]){
        [[MTGSDK sharedInstance] setUserPrivateInfoType:MTGUserPrivateType_GeneralData agree:isSet];
        
    }else if([statusKeyStr isEqualToString:@"authority_device_id"]){
        [[MTGSDK sharedInstance] setUserPrivateInfoType:MTGUserPrivateType_DeviceId agree:isSet];
        
    }else if([statusKeyStr isEqualToString:@"authority_gps"]){
        [[MTGSDK sharedInstance] setUserPrivateInfoType:MTGUserPrivateType_Gps agree:isSet];
        
    }
    
    printPrivateInfoStatus ();
}



int MTGCommon::userPrivateInfo(string statusKey)
{
    NSString *statusKeyStr = convertToNSString3(statusKey);
    
    MTGUserPrivateTypeInfo *userPrivateTypeInfo = [[MTGSDK sharedInstance] userPrivateInfo];
    printPrivateInfoStatus ();
    
    if([statusKeyStr isEqualToString:@"authority_general_data"]){
        return userPrivateTypeInfo.isGeneralDataAllowed;
        
    }else if([statusKeyStr isEqualToString:@"authority_device_id"]){
        return userPrivateTypeInfo.isDeviceIdAllowed;
        
    }else if([statusKeyStr isEqualToString:@"authority_gps"]){
        return userPrivateTypeInfo.isGpsAllowed;
        
    }else{
        return 0;
    }
}

void MTGCommon::printPrivateInfoStatus ()
{
    MTGUserPrivateTypeInfo *userPrivateTypeInfo = [[MTGSDK sharedInstance] userPrivateInfo];
    NSString * info = [NSString stringWithFormat: @"isGeneralDataAllowed = %d ,isDeviceIdAllowed = %d ,isGpsAllowed = %d",userPrivateTypeInfo.isGeneralDataAllowed,userPrivateTypeInfo.isDeviceIdAllowed,userPrivateTypeInfo.isGpsAllowed];
    NSLog(@"%@", info);
}

void MTGCommon::setConsentStatusInfoType (string statusType)
{
    NSString *statusTypeStr = convertToNSString3(statusType);
    
    if([statusTypeStr isEqualToString:@"1"]){
        [[MTGSDK sharedInstance] setConsentStatus:YES];
    }else{
        [[MTGSDK sharedInstance] setConsentStatus:NO];
    }
    
    printPrivateInfoStatus ();
}

bool MTGCommon::getConsentStatusInfoType ()
{
    BOOL status = [[MTGSDK sharedInstance] consentStatus];
    NSLog(@"consentStatus = %d", status);
    return status;
}
