//
//  MTGAdInterActive.mm
//  Cocos2dxSample-mobile
//
//  Created by YM on 2018/01/15.
//

#include "MTGAdInterActive.h"
#include "MTGAdInterActiveViewDelegate.h"

using namespace std;
using namespace cn::mtgsdk;

static MTGAdInterActiveViewDelegate * interActivedelegate = nil;
MTGInterActiveManager * interActiveAdManager;

NSString* convertToNSString4(string string)
{
    return [NSString stringWithUTF8String:string.c_str()];
}

void MTGAdInterActive::initMintegralSDK(string appid,string apikey){
    if (![MTGAdUtility isSDKInitialized]) {
        //init Mintegral Ads
        [[MTGSDK sharedInstance] setAppID:convertToNSString4(appid) ApiKey:convertToNSString4(apikey)];
        [MTGAdUtility sdkInitialized];
    }
}

void MTGAdInterActive::addCallbackInterActiveAd(InterActiveResultEvent callback)
{
    if(interActivedelegate == nil){
        interActivedelegate = [[MTGAdInterActiveViewDelegate alloc] init];
    }

    [interActivedelegate doingResultCallback:^(NSString *code,NSString *level){
        if (callback)
        {
            string   codeName=  [code UTF8String];
            string   levelName=  [level UTF8String];
            callback(codeName,levelName);
        }
    }];
}

void MTGAdInterActive::loadInterActiveAd(string unitid)
{
    if(interActivedelegate == nil){
        interActivedelegate = [[MTGAdInterActiveViewDelegate alloc] init];
    }
    
    UIWindow *keyWindow = [UIApplication sharedApplication].keyWindow;
    UIViewController *vc = keyWindow.rootViewController;
    while (vc.presentedViewController) {
        vc = vc.presentedViewController;
        
        if ([vc isKindOfClass:[UINavigationController class]]) {
            vc = [(UINavigationController *)vc visibleViewController];
        } else if ([vc isKindOfClass:[UITabBarController class]]) {
            vc = [(UITabBarController *)vc selectedViewController];
        }
    }
    
    if (!interActiveAdManager){
        interActiveAdManager = [[MTGInterActiveManager alloc] initWithUnitID:convertToNSString4(unitid) withViewController:vc];
        
        interActiveAdManager.delegate = interActivedelegate;
        
        [interActiveAdManager loadAd];
    }else{
        [interActiveAdManager loadAd];
    }
}

void MTGAdInterActive::showInterActiveAd()
{ 
    if(interActivedelegate == nil){
        interActivedelegate = [[MTGAdInterActiveViewDelegate alloc] init];
    }
    
    if(interActiveAdManager){
        [interActiveAdManager showAd];
    }
    
}

int MTGAdInterActive::getInterActiveStatus()
{
    if(interActiveAdManager){
        MTGInterActiveStatus status = [interActiveAdManager readyStatus];
        
        if(status == MTGInterActiveStatusNoAds){
            return 0;
        }else if(status == MTGInterActiveStatusMaterialLoading){
            return 1;
        }else if(status == MTGInterActiveStatusMaterialCompleted){
            return 2;
        }else{
            return 0;
        }
    }else{
        return 0;
    }
}
