//
//  MTGAdInterActiveViewDelegate.mm
//  MTGSDKCocos2dxSample-mobile
//
//  Created by YM on 2018/01/15.
//

#import <Foundation/Foundation.h>
#import "MTGAdInterActiveViewDelegate.h"
#import "cocos2d.h"

@implementation MTGAdInterActiveViewDelegate


-(void)doingResultCallback:(InterActiveResultEvent)callback{
   if (_callback != nil)
   {
      [_callback release];
      _callback = nil;
   }
   _callback = [callback copy];
}

#pragma mark - InterActive Delegate Methods
- (void) onInterActiveLoadSuccess:(MTGInterActiveResourceType)resourceType adManager:(MTGInterActiveManager *_Nonnull)adManager{
    
    if (_callback != nil)
    {
        _callback(@"onLoadSuccessInterActive",@"onLoadSuccess");
    }
}

- (void) onInterActiveLoadFailed:(nonnull NSError *)error adManager:(MTGInterActiveManager *_Nonnull)adManager{
    
    if (_callback != nil)
    {
       _callback(@"onLoadFailInterActive",[NSString stringWithFormat:@"%@",error]);
    }
}

 #pragma mark - MTGInterstitialAdShowDelegate Delegate
- (void) onInterActiveShowSuccess:(MTGInterActiveManager *_Nonnull)adManager{
    
    if (_callback != nil)
    {
        _callback(@"onAdShowInterActive",@"onAdShow");
    }    
}

- (void) onInterActiveShowFailed:(nonnull NSError *)error adManager:(MTGInterActiveManager *_Nonnull)adManager{
    
    if (_callback != nil)
    {
        _callback(@"onShowFailInterActive",[NSString stringWithFormat:@"%@",error]);
    }
}

- (void) onInterActiveAdDismissed:(MTGInterActiveManager *_Nonnull)adManager{
    
    if (_callback != nil)
    {
        _callback(@"onAdCloseInterActive",@"onAdClose");
    }
}

- (void) onInterActiveAdClick:(MTGInterActiveManager *_Nonnull)adManager{
    
    if (_callback != nil)
    {
        _callback(@"onAdClickedInterActive",@"onAdClicked");
    }
}

- (void) onInterActiveMaterialloadSuccess:(MTGInterActiveResourceType)resourceType adManager:(MTGInterActiveManager *_Nonnull)adManager{
    
    if (_callback != nil)
    {
        _callback(@"onMaterialLoadSuccessInterActive",@"onMaterialLoad");
    }
}

- (void)onInterActiveAdManager:(MTGInterActiveManager *_Nonnull)adManager playingComplete:(BOOL)completeOrNot{
    if (_callback != nil)
    {
        if(completeOrNot){
            _callback(@"onPlayCompleteInterActive",@"1");
        }else{
            _callback(@"onPlayCompleteInterActive",@"0");
        }
    }
    
}

@end
