//
//  MTGAdInterstitial.mm
//  Cocos2dxSample-mobile
//
//  Created by YM on 2018/01/15.
//

#include "MTGAdInterstitial.h"
#include "MTGAdInterstitialViewDelegate.h"

using namespace std;
using namespace cn::mtgsdk;

static MTGAdInterstitialViewDelegate * interstitialdelegate = nil;
MTGInterstitialAdManager * interstitialAdManager;

NSString* convertToNSString2(string string)
{
    return [NSString stringWithUTF8String:string.c_str()];
}

void MTGAdInterstitial::initMintegralSDK(string appid,string apikey){
    if (![MTGAdUtility isSDKInitialized]) {
        //init Mobvista Ads
        [[MTGSDK sharedInstance] setAppID:convertToNSString2(appid) ApiKey:convertToNSString2(apikey)];
        [MTGAdUtility sdkInitialized];
    }
}

void MTGAdInterstitial::addCallbackInterstitialAd(InterstitialResultEvent callback)
{
    if(interstitialdelegate == nil){
        interstitialdelegate = [[MTGAdInterstitialViewDelegate alloc] init];
    }

    [interstitialdelegate doingResultCallback:^(NSString *code,NSString *level){
        if (callback)
        {
            string   codeName=  [code UTF8String];
            string   levelName=  [level UTF8String];
            callback(codeName,levelName);
        }
    }];
}

void MTGAdInterstitial::loadInterstitialAd(string unitid)
{
    if(interstitialdelegate == nil){
        interstitialdelegate = [[MTGAdInterstitialViewDelegate alloc] init];
    }
    
    if (!interstitialAdManager){
        interstitialAdManager = [[MTGInterstitialAdManager alloc] initWithUnitID:convertToNSString2(unitid) adCategory:(MTGInterstitialAdCategory)0];
        [interstitialAdManager loadWithDelegate:interstitialdelegate];
    }else{
        [interstitialAdManager loadWithDelegate:interstitialdelegate];
    }
}

void MTGAdInterstitial::showInterstitialAd()
{
    UIWindow *keyWindow = [UIApplication sharedApplication].keyWindow;
    UIViewController *vc = keyWindow.rootViewController;
    while (vc.presentedViewController) {
        vc = vc.presentedViewController;
        
        if ([vc isKindOfClass:[UINavigationController class]]) {
            vc = [(UINavigationController *)vc visibleViewController];
        } else if ([vc isKindOfClass:[UITabBarController class]]) {
            vc = [(UITabBarController *)vc selectedViewController];
        }
    }
    
    if(interstitialdelegate == nil){
        interstitialdelegate = [[MTGAdInterstitialViewDelegate alloc] init];
    }
    
    if(interstitialAdManager){
        [interstitialAdManager showWithDelegate:interstitialdelegate presentingViewController:vc];
    }
    
}
