//
//  MTGAdInterstitialViewDelegate.mm
//  MTGSDKCocos2dxSample-mobile
//
//  Created by YM on 2018/01/15.
//

#import <Foundation/Foundation.h>
#import "MTGAdInterstitialViewDelegate.h"
#import "cocos2d.h"

@implementation MTGAdInterstitialViewDelegate


-(void)doingResultCallback:(InterstitialResultEvent)callback{
   if (_callback != nil)
   {
      [_callback release];
      _callback = nil;
   }
   _callback = [callback copy];
}

#pragma mark - Interstitial Delegate Methods
- (void) onInterstitialLoadSuccess{
    if (_callback != nil)
    {
        _callback(@"onLoadSuccessInterstitial",@"onLoadSuccess");
    }
}

- (void) onInterstitialLoadFail:(nonnull NSError *)error{
    if (_callback != nil)
    {
       _callback(@"onLoadFailInterstitial",[NSString stringWithFormat:@"%@",error]);
    }
}

 #pragma mark - MTGInterstitialAdShowDelegate Delegate
- (void) onInterstitialShowSuccess{
    if (_callback != nil)
    {
        _callback(@"onAdShowInterstitial",@"onAdShow");
    }    
}

- (void) onInterstitialShowFail:(nonnull NSError *)error{
    if (_callback != nil)
    {
        _callback(@"onShowFailInterstitial",[NSString stringWithFormat:@"%@",error]);
    }
}

- (void) onInterstitialClosed{
    if (_callback != nil)
    {
        _callback(@"onAdCloseInterstitial",@"onAdClose");
    }
}

- (void) onInterstitialAdClick{
    if (_callback != nil)
    {
        _callback(@"onAdClickedInterstitial",@"onAdClicked");
    }
}

@end
