//
//  MTGAdInterstitialVideo.mm
//  Cocos2dxSample-mobile
//
//  Created by YM on 2018/01/01.
//

#include "MTGAdInterstitialVideo.h"
#include "MTGAdInterstitialVideoViewDelegate.h"

using namespace std;
using namespace cn::mtgsdk;

static MTGAdInterstitialVideoViewDelegate * interstitialVideodelegate = nil;
MTGInterstitialVideoAdManager * interstitialVideoAdManager;

NSString* convertToNSString1(string string)
{
    return [NSString stringWithUTF8String:string.c_str()];
}

void MTGAdInterstitialVideo::initMintegralSDK(string appid,string apikey){
    if (![MTGAdUtility isSDKInitialized]) {
        [[MTGSDK sharedInstance] setAppID:convertToNSString1(appid) ApiKey:convertToNSString1(apikey)];
        [MTGAdUtility sdkInitialized];
    }
}

void MTGAdInterstitialVideo::addCallbackInterstitialVideoAd(InterstitialVideoResultEvent callback)
{
    if(interstitialVideodelegate == nil){
        interstitialVideodelegate = [[MTGAdInterstitialVideoViewDelegate alloc] init];
    }

    [interstitialVideodelegate doingResultCallback:^(NSString *code,NSString *level){
        if (callback)
        {
            string   codeName=  [code UTF8String];
            string   levelName=  [level UTF8String];
            callback(codeName,levelName);
        }
    }];
}

void MTGAdInterstitialVideo::loadInterstitialVideoAd(string unitid)
{
    if(interstitialVideodelegate == nil){
        interstitialVideodelegate = [[MTGAdInterstitialVideoViewDelegate alloc] init];
    }
    
    if (!interstitialVideoAdManager){
        interstitialVideoAdManager = [[MTGInterstitialVideoAdManager alloc] initWithUnitID:convertToNSString1(unitid) delegate:interstitialVideodelegate];
        [interstitialVideoAdManager loadAd];
    }else{
        [interstitialVideoAdManager loadAd];
    }
}

void MTGAdInterstitialVideo::showInterstitialVideoAd(string unitid)
{
    UIWindow *keyWindow = [UIApplication sharedApplication].keyWindow;
    UIViewController *vc = keyWindow.rootViewController;
    while (vc.presentedViewController) {
        vc = vc.presentedViewController;
        
        if ([vc isKindOfClass:[UINavigationController class]]) {
            vc = [(UINavigationController *)vc visibleViewController];
        } else if ([vc isKindOfClass:[UITabBarController class]]) {
            vc = [(UITabBarController *)vc selectedViewController];
        }
    }
    
    if(interstitialVideodelegate == nil){
        interstitialVideodelegate = [[MTGAdInterstitialVideoViewDelegate alloc] init];
    }
    
    [interstitialVideoAdManager showFromViewController:vc ];
    
}

