//
//  MTGAdInterstitialVideoBridge.cpp
//  Cocos2dxSample-mobile
//
//  Created by YM on 2018/01/01.
//

#include "MTGAdInterstitialVideoBridge.h"
#include "cocos2d.h"

USING_NS_CC;

using namespace cn::mtgsdk;

#if (CC_TARGET_PLATFORM == CC_PLATFORM_ANDROID)

#include "platform/android/jni/JniHelper.h"
#include <jni.h>

const char* AppActivityCalssName1 = "org/cocos2dx/mtgad/InterstitialVideo/MTGAdInterstitialVideo";

InterstitialVideoResultEvent onInterstitialVideoCallBack;

//JNI调用C++

extern "C" {

JNIEXPORT void JNICALL Java_org_cocos2dx_mtgad_InterstitialVideo_MTGAdInterstitialVideo_dispatchStatusEventAsync(JNIEnv *env, jclass, jstring jcode, jstring jlevel) {
    auto tempID = env->GetStringUTFChars(jcode, NULL);
    string codeID = tempID;
    env->ReleaseStringUTFChars(jcode, tempID);

    auto tempID1 = env->GetStringUTFChars(jlevel, NULL);
    string levelID = tempID1;
    env->ReleaseStringUTFChars(jlevel, tempID1);

    onInterstitialVideoCallBack(codeID,levelID);
}
}

void releaseMethod1(JniMethodInfo &mi) {
    if(mi.classID != NULL)
        mi.env->DeleteLocalRef(mi.classID);
}

//initsdk
void MTGAdInterstitialVideoBridge::initMintegralSDK(std::string appid,std::string apikey)
{
    cocos2d::JniMethodInfo mi;
    if (cocos2d::JniHelper::getStaticMethodInfo(mi, AppActivityCalssName1, "initMintegralSDK", "(Ljava/lang/String;Ljava/lang/String;)V")) {
        
        jstring jappid = mi.env->NewStringUTF( appid.c_str() );
        jstring japikey = mi.env->NewStringUTF( apikey.c_str() );
        
        mi.env->CallStaticVoidMethod(mi.classID, mi.methodID,jappid,japikey);
        
        releaseMethod1(mi);
    }
    else{
        log("jni:initMintegralSDK false");
    }
}

//addcallback iv
void MTGAdInterstitialVideoBridge::addCallbackInterstitialVideoAd(InterstitialVideoResultEvent callback)
{
    onInterstitialVideoCallBack = callback;
}

//load iv
void MTGAdInterstitialVideoBridge::loadInterstitialVideoAd(std::string unitid)
{
    cocos2d::JniMethodInfo mi;
    if (cocos2d::JniHelper::getStaticMethodInfo(mi, AppActivityCalssName1, "loadInterstitialVideoAd", "(Ljava/lang/String;)V")) {
        
        jstring junitid = mi.env->NewStringUTF( unitid.c_str() );
        
        mi.env->CallStaticVoidMethod(mi.classID, mi.methodID,junitid);
        
        releaseMethod1(mi);
    }else{
        log("jni:loadInterstitialVideoAd false");
    }
}

//show iv
void MTGAdInterstitialVideoBridge::showInterstitialVideoAd(std::string unitid)
{
    cocos2d::JniMethodInfo mi;
    if (cocos2d::JniHelper::getStaticMethodInfo(mi, AppActivityCalssName1, "showInterstitialVideoAd", "(Ljava/lang/String;)V")) {
        
        jstring junitid = mi.env->NewStringUTF( unitid.c_str() );
        
        mi.env->CallStaticVoidMethod(mi.classID, mi.methodID,junitid);
        
        releaseMethod1(mi);
    }
    else{
        log("jni:showInterstitialVideoAd false");
    }
}

#elif (CC_TARGET_PLATFORM == CC_PLATFORM_IOS)

#include "MTGAdInterstitialVideo.h"

void MTGAdInterstitialVideoBridge::initMintegralSDK(string appid,string apikey)
{
    MTGAdInterstitialVideo::initMintegralSDK(appid, apikey);
    return;
}
void MTGAdInterstitialVideoBridge::addCallbackInterstitialVideoAd(InterstitialVideoResultEvent callback)
{
    MTGAdInterstitialVideo::addCallbackInterstitialVideoAd(callback);
    return;
}
void MTGAdInterstitialVideoBridge::loadInterstitialVideoAd(string unitid)
{
    MTGAdInterstitialVideo::loadInterstitialVideoAd(unitid);
    return;
}
void MTGAdInterstitialVideoBridge::showInterstitialVideoAd(string unitid)
{
    MTGAdInterstitialVideo::showInterstitialVideoAd(unitid);
    return;
}

#endif
