//
//  MTGAdInterstitialVideoViewDelegate.mm
//  MTGSDKCocos2dxSample-mobile
//
//  Created by YM on 2018/01/01.
//

#import <Foundation/Foundation.h>
#import "MTGAdInterstitialVideoViewDelegate.h"
#import "cocos2d.h"

@implementation MTGAdInterstitialVideoViewDelegate


-(void)doingResultCallback:(InterstitialVideoResultEvent)callback{
   if (_callback != nil)
   {
      [_callback release];
      _callback = nil;
   }
   _callback = [callback copy];
}

 #pragma mark - MTGInterstitialVideoDelegate Delegate

- (void) onInterstitialAdLoadSuccess:(MTGInterstitialVideoAdManager *_Nonnull)adManager{
    if (_callback != nil)
    {
        _callback(@"onAdLoadSuccess",@"");
    }
}

 //Load Interstitial Video Ad Success Delegate
- (void)onInterstitialVideoLoadSuccess:(MTGInterstitialVideoAdManager *_Nonnull)adManager
 {
     if (_callback != nil)
     {
         _callback(@"onLoadSuccessInterstitialVideo",@"");
     }
 }
 
 //Load Interstitial Video Ad Failed Delegate
- (void)onInterstitialVideoLoadFail:(nonnull NSError *)error adManager:(MTGInterstitialVideoAdManager *_Nonnull)adManager
 {
     if (_callback != nil)
     {
         _callback(@"onLoadFailInterstitialVideo",@"");
     }
 }

 //Show Interstitial Video Ad Success Delegate
- (void)onInterstitialVideoShowSuccess:(MTGInterstitialVideoAdManager *_Nonnull)adManager
 {
     if (_callback != nil)
    {
        _callback(@"onAdShowInterstitialVideo",@"onAdShowInterstitialVideo");
     }
 }
 
 //Show Interstitial Video Ad Failed Delegate
- (void)onInterstitialVideoShowFail:(nonnull NSError *)error adManager:(MTGInterstitialVideoAdManager *_Nonnull)adManager
 {
     if (_callback != nil)
     {
         _callback(@"onShowFailInterstitialVideo",[NSString stringWithFormat:@"%@",error]);
     }
 }
 
 //About InterstitialInfo Delegate
- (void)onInterstitialVideoAdDismissedWithConverted:(BOOL)converted adManager:(MTGInterstitialVideoAdManager *_Nonnull)adManager
{
     if (_callback != nil)
     {
         _callback(@"onAdCloseInterstitialVideo",@"onAdCloseInterstitialVideo");
     }
 }

 //About Interstitial Video Click Delegate
- (void)onInterstitialVideoAdClick:(MTGInterstitialVideoAdManager *_Nonnull)adManager
{
     if (_callback != nil)
     {
         _callback(@"onAdClickedInterstitialVideo",@"");
     }
 }


@end
