//
//  MTGAdRewardVideo.mm
//  Cocos2dxSample-mobile
//
//  Created by YM on 2017/12/19.
//

#include "MTGAdRewardVideo.h"
#include "MTGAdRewardVideoViewDelegate.h"
#import "../MTGAdUtility.h"

using namespace std;
using namespace cn::mtgsdk;

static MTGAdRewardVideoViewDelegate * rewardVideodelegate = nil;

NSString* convertToNSString(string string)
{
    return [NSString stringWithUTF8String:string.c_str()];
}

void MTGAdRewardVideo::initMintegralSDK(string appid,string apikey){
    
    if (![MTGAdUtility isSDKInitialized]) {
        [[MTGSDK sharedInstance] setAppID:convertToNSString(appid) ApiKey:convertToNSString(apikey)];
        [MTGAdUtility sdkInitialized];
    }
}

void MTGAdRewardVideo::addCallbackRewardVideoAd(RewardVideoResultEvent callback)
{
    if(rewardVideodelegate == nil){
        rewardVideodelegate = [[MTGAdRewardVideoViewDelegate alloc] init];
    }
    
    [rewardVideodelegate doingResultCallback:^(NSString *code,NSString *level){
        if (callback)
        {
            string   codeName=  [code UTF8String];
            string   levelName=  [level UTF8String];
            callback(codeName,levelName);
        }
    }];
}

void MTGAdRewardVideo::loadRewardVideoAd(string unitid)
{
    if(rewardVideodelegate == nil){
        rewardVideodelegate = [[MTGAdRewardVideoViewDelegate alloc] init];
    }
    
    [[MTGRewardAdManager sharedInstance] loadVideo:convertToNSString(unitid) delegate:rewardVideodelegate];
}

void MTGAdRewardVideo::showRewardVideoAd(string unitid,string rewardid,string userid)
{
    UIWindow *keyWindow = [UIApplication sharedApplication].keyWindow;
    UIViewController *vc = keyWindow.rootViewController;
    while (vc.presentedViewController) {
        vc = vc.presentedViewController;
        
        if ([vc isKindOfClass:[UINavigationController class]]) {
            vc = [(UINavigationController *)vc visibleViewController];
        } else if ([vc isKindOfClass:[UITabBarController class]]) {
            vc = [(UITabBarController *)vc selectedViewController];
        }
    }
    
    if(rewardVideodelegate == nil){
        rewardVideodelegate = [[MTGAdRewardVideoViewDelegate alloc] init];
    }
    
    [[MTGRewardAdManager sharedInstance] showVideo:convertToNSString(unitid) withRewardId:convertToNSString(rewardid) userId:convertToNSString(userid) delegate:rewardVideodelegate viewController:vc];
}
bool MTGAdRewardVideo::isReadyRewardVideoAd(string unitid)
{
    BOOL success = NO;
    success = [[MTGRewardAdManager sharedInstance] isVideoReadyToPlay:convertToNSString(unitid)];
    
    if(success == YES){
        return true;
    }else{
        return false;
    }
}

void MTGAdRewardVideo::cleanVideoCacheRewardVideoAd()
{
    [[MTGRewardAdManager sharedInstance] cleanAllVideoFileCache];
}
