//
//  MTGAdRewardVideoViewDelegate.mm
//  MTGSDKCocos2dxSample-mobile
//
//  Created by YM on 2017/12/19.
//

#import <Foundation/Foundation.h>
#import "MTGAdRewardVideoViewDelegate.h"
#import "../MTGAdUtility.h"
#import "cocos2d.h"

@interface MTGRewardAdModel : NSObject
@property (nonatomic, copy  ) NSString  *rewardName;
@property (nonatomic, assign) NSInteger rewardAmount;
@end

@implementation MTGRewardAdModel
@end

@implementation MTGAdRewardVideoViewDelegate


-(void)doingResultCallback:(RewardVideoResultEvent)callback{
   if (_callback != nil)
   {
      [_callback release];
      _callback = nil;
   }
   _callback = [callback copy];
}

 #pragma mark - MTGRewardAdLoadDelegate Delegate

- (void)onAdLoadSuccess:(nullable NSString *)unitId
{
    if (_callback != nil)
    {
        _callback(@"onAdLoadSuccess",unitId);
    }
}
 //Load Reward Video Ad Success Delegate
 - (void)onVideoAdLoadSuccess:(NSString *)unitId
 {
     if (_callback != nil)
     {
         _callback(@"onLoadSuccessRewardVideo",unitId);
     }
 }
 
 //Load Reward Video Ad Failed Delegate
 - (void)onVideoAdLoadFailed:(NSString *)unitId error:(NSError *)error
 {
     if (_callback != nil)
     {
         _callback(@"onLoadFailRewardVideo",unitId);
     }
 }
 
 #pragma mark - MTGRewardAdShowDelegate Delegate
 //Show Reward Video Ad Success Delegate
 - (void)onVideoAdShowSuccess:(NSString *)unitId
 {
     if (_callback != nil)
    {
        _callback(@"onAdShowRewardVideo",@"onAdShowRewardVideo");
     }
 }
 
 //Show Reward Video Ad Failed Delegate
 - (void)onVideoAdShowFailed:(NSString *)unitId withError:(NSError *)error
 {
     if (_callback != nil)
     {
         _callback(@"onShowFailRewardVideo",[NSString stringWithFormat:@"%@",error]);
     }
 }
 
 //About RewardInfo Delegate
 - (void)onVideoAdDismissed:(NSString *)unitId withConverted:(BOOL)converted withRewardInfo:(MTGRewardAdInfo *)rewardInfo
 {
     if (_callback != nil)
     {
         if (rewardInfo) {

             MTGRewardAdModel *model = nil;
             model = [[MTGRewardAdModel alloc] init];
             
             model.rewardName = rewardInfo.rewardName;
             model.rewardAmount = rewardInfo.rewardAmount;
             
             NSString *rewardInfoStr = [MTGAdUtility convertJsonFromObject:rewardInfo withClassName:NSStringFromClass([MTGRewardAdModel class])];
             
             _callback(@"onAdCloseRewardVideo",rewardInfoStr);
         }else {
             _callback(@"onAdCloseRewardVideo",@"failComplete");
         }
     }
 }
 
 - (void)onVideoAdClicked:(nullable NSString *)unitId
{
    NSLog(@"click");
     if (_callback != nil)
     {
         _callback(@"onAdClickedRewardVideo",unitId);
     }
 }


@end
