package org.cocos2dx.mtgad.InterActive;

import android.text.TextUtils;
import android.util.Log;

import java.util.Map;
import java.util.HashMap;
import java.util.concurrent.Callable;
import java.util.concurrent.FutureTask;

import org.cocos2dx.lib.Cocos2dxHelper;
import org.cocos2dx.mtgad.MTGAdUtility;
import android.widget.FrameLayout;

import com.mintegral.msdk.MIntegralSDK;
import com.mintegral.msdk.MIntegralConstans;
import com.mintegral.msdk.interactiveads.out.InteractiveAdsListener;
import com.mintegral.msdk.interactiveads.out.MTGInteractiveHandler;
import com.mintegral.msdk.out.MIntegralSDKFactory;



public class MTGAdInterActive{

    private static MTGInteractiveHandler mInteractiveHandler;
    private static FrameLayout entranceViewLayout;
    private static int adType = 0;

    //init Mintegral
    public static void initMTGSdk(final String appid,final String apikey){
        if(!MTGAdUtility.isSDKInitialized()) {

            //init sdk
            MIntegralSDK sdk = MIntegralSDKFactory.getMIntegralSDK();
            Map<String, String> map = sdk.getMTGConfigurationMap(appid, apikey);
            if (!TextUtils.isEmpty("")) {
                map.put("applicationID", "");
            }
            sdk.init(map, Cocos2dxHelper.getActivity());
            MTGAdUtility.sdkInitialized();
        }
    }

    //init interstitial
    public static void initInterActiveHander(final String unitid){
        HashMap<String, Object> hashMap = new HashMap<String, Object>();
        hashMap.put(MIntegralConstans.PROPERTIES_UNIT_ID, unitid);

        mInteractiveHandler = new MTGInteractiveHandler(Cocos2dxHelper.getActivity(), hashMap);
        String placeholderUrl = "http://cdn-adn.rayjump.com/cdn-adn/offersync/18/04/20/10/22/5ad94efcddbb0.png";
        String placeHolderGifUrl = "http://img18.3lian.com/d/file/201710/14/2e593fb208dd49c36db8eb88ad68c1fd.gif";
        mInteractiveHandler.setEntranceView(entranceViewLayout, placeHolderGifUrl);
        mInteractiveHandler.setInteractiveAdsListener(new InteractiveAdsListener() {
                    @Override
                    public void onInteractivelLoadSuccess(int restype) {

                        dispatchStatusEventAsync("onLoadSuccessInterActive","onLoadSuccess");
                        adType = restype;
                    }

                    @Override
                    public void onInterActiveMaterialLoadSuccess() {
                        dispatchStatusEventAsync("onMaterialLoadSuccessInterActive","onMaterialLoad");
                    }

                    @Override
                    public void onInteractiveLoadFail(String errorMsg) {
                        dispatchStatusEventAsync("onLoadFailInterActive",errorMsg);

                    }

                    @Override
                    public void onInteractiveShowSuccess() {
                        dispatchStatusEventAsync("onAdShowInterActive","onAdShow");

                    }

                    @Override
                    public void onInteractiveShowFail(String errorMsg) {
                        dispatchStatusEventAsync("onShowFailInterActive",errorMsg);

                    }

                    @Override
                    public void onInteractiveClosed() {
                        dispatchStatusEventAsync("onAdCloseInterActive","onAdClose");

                    }

                    @Override
                    public void onInteractiveAdClick() {
                        dispatchStatusEventAsync("onAdClickedInterActive","onAdClicked");

                    }

                    public void onInteractivePlayingComplete(boolean completeOrNot) {
                        if (completeOrNot) {
                            dispatchStatusEventAsync("onPlayCompleteInterActive", "1");
                        } else {
                            dispatchStatusEventAsync("onPlayCompleteInterActive", "0");
                        }
                    }

                });
    }

    //load interstitial
    public static void interActiveLoad(){
        if (mInteractiveHandler != null) {
            mInteractiveHandler.load();
        }else{
            Log.e("error load","please init");
        }
    }

    //show interstitial
    public static void interActiveShow(){
        if (mInteractiveHandler != null) {
            mInteractiveHandler.show();
        }else{
            Log.e("error show","please load");
        }
    }


    public static void initMintegralSDK(final String appid,final String apikey) {

        FutureTask<String> task = new FutureTask<String>(new Callable<String>() {
            @Override
            public String call() throws Exception {

                initMTGSdk(appid,apikey);

                return "";
            }
        });

        try {
            Cocos2dxHelper.getActivity().runOnUiThread(task);
        } catch (Exception e) {}
    }
    public static void loadInterActiveAd(final String unitid) {

        FutureTask<String> task = new FutureTask<String>(new Callable<String>() {
            @Override
            public String call() throws Exception {

                if(mInteractiveHandler != null){
                    mInteractiveHandler = null;
                }
                initInterActiveHander(unitid);
                interActiveLoad();

                return "";
            }
        });
        try {
            Cocos2dxHelper.getActivity().runOnUiThread(task);
        } catch (Exception e) {}
    }
    public static void showInterActiveAd() {

        FutureTask<String> task = new FutureTask<String>(new Callable<String>() {
            @Override
            public String call() throws Exception {

                interActiveShow();

                return "";
            }
        });

        try {
            Cocos2dxHelper.getActivity().runOnUiThread(task);
        } catch (Exception e) {}
    }

    public static int getInterActiveStatus() {

        FutureTask<Integer> task = new FutureTask<Integer>(new Callable<Integer>() {
            @Override
            public Integer call() throws Exception {
                return adType;
            }
        });

        try {
            //Cocos2dxHelper.getActivity().runOnUiThread(task);
            Integer integer = adType; //task.get();
            Log.e("get ", ""+integer);
            return integer;
        } catch (Exception e) {return 0;}
    }
    //callBack
    private static native void dispatchStatusEventAsync(String code,String level);

}
