package org.cocos2dx.mtgad.InterstitialVideo;

import android.text.TextUtils;
import android.util.Log;

import java.util.Map;
import java.util.concurrent.Callable;
import java.util.concurrent.FutureTask;

import org.cocos2dx.lib.Cocos2dxHelper;
import org.cocos2dx.mtgad.MTGAdUtility;

import com.mintegral.msdk.MIntegralSDK;
import com.mintegral.msdk.out.MIntegralSDKFactory;

import com.mintegral.msdk.interstitialvideo.out.InterstitialVideoListener;
import com.mintegral.msdk.interstitialvideo.out.MTGInterstitialVideoHandler;

public class MTGAdInterstitialVideo{

    private static MTGInterstitialVideoHandler mtgInterstitialVideoHandler;

    //init Mintegral
    public static void initMTGSdk(final String appid,final String apikey){
        if(!MTGAdUtility.isSDKInitialized()) {

            //init sdk
            MIntegralSDK sdk = MIntegralSDKFactory.getMIntegralSDK();
            Map<String, String> map = sdk.getMTGConfigurationMap(appid, apikey);
            if (!TextUtils.isEmpty("")) {
                map.put("applicationID", "");
            }
            sdk.init(map, Cocos2dxHelper.getActivity());
            MTGAdUtility.sdkInitialized();
        }
    }

    //init RewardVideo
    public static void initInterstitialVideoHander(final String unitid){
        mtgInterstitialVideoHandler = new MTGInterstitialVideoHandler(Cocos2dxHelper.getActivity(), unitid);
        mtgInterstitialVideoHandler.setInterstitialVideoListener(new InterstitialVideoListener() {

                    public void onLoadSuccess(String unitId)
                    {
                        dispatchStatusEventAsync("onAdLoadSuccess", unitId);
                    }

                    public void onVideoLoadSuccess(String unitId)
                    {
                        dispatchStatusEventAsync("onLoadSuccessInterstitialVideo",unitId);
                    }

                    public void onVideoLoadFail(String errorMsg)
                    {
                        dispatchStatusEventAsync("onLoadFailInterstitialVideo",errorMsg);
                    }

                    public void onAdShow()
                    {
                        dispatchStatusEventAsync("onAdShowInterstitialVideo","onAdShowInterstitialVideo");
                    }

                    public void onShowFail(String errorMsg)
                    {
                        dispatchStatusEventAsync("onShowFailInterstitialVideo",errorMsg);
                    }

                    public void onAdClose(boolean arg0)
                    {
                        dispatchStatusEventAsync("onAdCloseInterstitialVideo","onAdCloseInterstitialVideo");
                    }

                    public void onVideoAdClicked(String unitId)
                    {
                        dispatchStatusEventAsync("onAdClickedInterstitialVideo",unitId);
                    }
                });
    }

    //load rv
    public static void interstitialVideoLoad(){
        if (mtgInterstitialVideoHandler != null) {
            mtgInterstitialVideoHandler.load();
        }else{
            Log.e("error load","please init");
        }
    }

    //show rv
    public static void interstitialVideoShow(){
        if (mtgInterstitialVideoHandler != null) {
            mtgInterstitialVideoHandler.show();
        }else{
            Log.e("error show","please load");
        }
    }


    public static void initMintegralSDK(final String appid,final String apikey) {

        FutureTask<String> task = new FutureTask<String>(new Callable<String>() {
            @Override
            public String call() throws Exception {

                initMTGSdk(appid,apikey);

                return "";
            }
        });

        try {
            Cocos2dxHelper.getActivity().runOnUiThread(task);
        } catch (Exception e) {}
    }
    public static void loadInterstitialVideoAd(final String unitid) {

        FutureTask<String> task = new FutureTask<String>(new Callable<String>() {
            @Override
            public String call() throws Exception {

                if(mtgInterstitialVideoHandler != null){
                    mtgInterstitialVideoHandler = null;
                }
                initInterstitialVideoHander(unitid);

                interstitialVideoLoad();

                return "";
            }
        });
        try {
            Cocos2dxHelper.getActivity().runOnUiThread(task);
        } catch (Exception e) {}
    }
    public static void showInterstitialVideoAd(final String unitid) {

        FutureTask<String> task = new FutureTask<String>(new Callable<String>() {
            @Override
            public String call() throws Exception {

                interstitialVideoShow();

                return "";
            }
        });

        try {
            Cocos2dxHelper.getActivity().runOnUiThread(task);
        } catch (Exception e) {}
    }
    //callBack
    private static native void dispatchStatusEventAsync(String code,String level);

}
