package org.cocos2dx.mtgad;

import android.util.Log;
import org.cocos2dx.lib.Cocos2dxHelper;

import com.mintegral.msdk.MIntegralSDK;
import com.mintegral.msdk.MIntegralConstans;
import com.mintegral.msdk.out.MIntegralSDKFactory;

import com.mintegral.msdk.base.controller.authoritycontroller.AuthorityInfoBean;
import com.mintegral.msdk.base.controller.authoritycontroller.CallBackForDeveloper;

import java.util.Map;
import java.util.concurrent.Callable;
import java.util.concurrent.FutureTask;

/**
 * Created by m on 2018/5/16.
 */

public class MTGCommon {

    //private static final String AUTHORITY_KEY_ALL_INFO = "authority_all_info";
    private static final String AUTHORITY_KEY_GENERAL_DATA = "authority_general_data";
    private static final String AUTHORITY_KEY_DEVICE_ID = "authority_device_id";
    private static final String AUTHORITY_KEY_GPS = "authority_gps";
    private static final String AUTHORITY_KEY_IMEI_MAC = "authority_imei_mac";
    private static final String AUTHORITY_KEY_ANDROID_ID = "authority_android_id";
    private static final String AUTHORITY_KEY_APP_LIST = "authority_applist";
    private static final String AUTHORITY_KEY_APP_DOWNLOAD = "authority_app_download";
    private static final String AUTHORITY_KEY_APP_PROGRESS = "authority_app_progress";

    /**
     * 获取IMEI
     *
     * @return
     */
    /*
    public static String getIMEI(Context context) {

        try {
            if (TextUtils.isEmpty(deviceid)) {
                TelephonyManager TelephonyMgr = (TelephonyManager) context.getSystemService(Context.TELEPHONY_SERVICE);
                deviceid = TelephonyMgr.getDeviceId();
                if (deviceid == null) {
                    deviceid = CommonDeviceUtil.getSelfId(context);
                    if (deviceid == null) {
                        deviceid = "";
                    }

                }
                // deviceid = CommonBase64Util.newBase64Encode(deviceid);
        }

        } catch (Exception e) {
            // e.printStackTrace();
            deviceid = "";
        }
        return deviceid;
    }
    */

    //init Mobvista
    public static void initMTGSdk(final String appid,final String apikey){
        if(!MTGAdUtility.isSDKInitialized()) {
            //init sdk
            MIntegralSDK sdk = MIntegralSDKFactory.getMIntegralSDK();
            Map<String, String> map = sdk.getMTGConfigurationMap(appid, apikey);
            sdk.init(map, Cocos2dxHelper.getActivity());
            MTGAdUtility.sdkInitialized();
        }
    }

    public static void showUserPrivateInfoTipsSelf(){
        Log.e("MTGCocos2dx", "mtgPrivateinfoShow");
        MIntegralSDK sdk = MIntegralSDKFactory.getMIntegralSDK();

        sdk.showUserPrivateInfoTips(Cocos2dxHelper.getActivity(), new CallBackForDeveloper() {
            //@Override
            public void onAuthorityInfoBean(AuthorityInfoBean authorityInfoBean) {
                //用户选择之后，回调到这个函数，并且返回各个用户信息是否获取的开关，建议开发者在这个时候再去做SDK的初始化。
                printPrivateInfoStatus();

                Log.e("onShowUserInfoTips","YES");
                dispatchStatusEventAsync("onShowUserInfoTips","YES");
            }
            //@Override
            public void onShowPopWindowStatusFaile(String result) {
                //如果弹窗失败，开发者可以主动设置不上报用户信息
                printPrivateInfoStatus();

                Log.e("onShowUserInfoTips","NO");
                dispatchStatusEventAsync("onShowUserInfoTips","NO");

            }
            //@Override
            public void onShowPopWindowStatusSucessful() {
            }
        });

    }

    public static void setUserPrivateInfoTypeSelf(String statusKey, String statusType){
        Log.e("MTGCocos2dx", "mtgPrivateinfoSet");
        MIntegralSDK sdk = MIntegralSDKFactory.getMIntegralSDK();

        if(statusType.equals("ON")){
            sdk.setUserPrivateInfoType(Cocos2dxHelper.getActivity(), statusKey, MIntegralConstans.IS_SWITCH_ON);
        }else{
            sdk.setUserPrivateInfoType(Cocos2dxHelper.getActivity(), statusKey, MIntegralConstans.IS_SWITCH_OFF);
        }
        printPrivateInfoStatus();
    }

    public static int userPrivateInfoSelf(String fstatusKey){
        Log.e("MTGCocos2dx", "mtgPrivateinfoGet");
        MIntegralSDK sdk = MIntegralSDKFactory.getMIntegralSDK();

        //主动查询  各个用户信息是否获取的开关状态
        AuthorityInfoBean authorityInfoBean = sdk.userPrivateInfo(Cocos2dxHelper.getActivity());
        if(authorityInfoBean  == null){
            Log.e("MTGAdobeAirLogCo", " authorityInfoBean is null");
            return 0;
        }

        printPrivateInfoStatus();

        if(fstatusKey.equals(AUTHORITY_KEY_GENERAL_DATA)){
            return authorityInfoBean.getAuthGenDataStatus();

        }else if(fstatusKey.equals(AUTHORITY_KEY_DEVICE_ID)){
            return authorityInfoBean.getAuthDeviceIdStatus();

        }else if(fstatusKey.equals(AUTHORITY_KEY_GPS)){
            return authorityInfoBean.getAuthGpsStatus();

        }else if(fstatusKey.equals(AUTHORITY_KEY_IMEI_MAC)){
            return authorityInfoBean.getAuthImeiAndMacStatus();

        }else if(fstatusKey.equals(AUTHORITY_KEY_ANDROID_ID)){
            return authorityInfoBean.getAuthAndroidIdStatus();

        }else if(fstatusKey.equals(AUTHORITY_KEY_APP_LIST)){
            return authorityInfoBean.getAuthAppListStatus();

        }else if(fstatusKey.equals(AUTHORITY_KEY_APP_DOWNLOAD)){
            return authorityInfoBean.getAuthAppDownloadStatus();

        }else if(fstatusKey.equals(AUTHORITY_KEY_APP_PROGRESS)){
            return authorityInfoBean.getAuthAppProgressStatus();

        }else{
            Log.e("MTGCocos2dx", " fstatusKey is null");
            return 0;
        }
    }

    public static void printPrivateInfoStatus()
    {
        MIntegralSDK sdk = MIntegralSDKFactory.getMIntegralSDK();

        //主动查询  各个用户信息是否获取的开关状态
        AuthorityInfoBean authorityInfoBean = sdk.userPrivateInfo(Cocos2dxHelper.getActivity());

        String  infos = "GenData:"+authorityInfoBean.getAuthGenDataStatus()
                +" DeviceId:"+authorityInfoBean.getAuthDeviceIdStatus()
                +" Gps:"+authorityInfoBean.getAuthGpsStatus()
                +" ImeiAndMac:"+authorityInfoBean.getAuthImeiAndMacStatus()
                +" AndroidId:"+authorityInfoBean.getAuthAndroidIdStatus()
                +" AppList:"+authorityInfoBean.getAuthAppListStatus()
                +" AppDownload:"+authorityInfoBean.getAuthAppDownloadStatus()
                +" AppProgress:"+authorityInfoBean.getAuthAppProgressStatus();

        Log.e("getAuthPrivateInfo", infos);
    }


    public static void setConsentStatusInfoTypeSelf(String statusType)
    {
        Log.e("setConsentStatus : ", ""+statusType);

        MIntegralSDK sdk = MIntegralSDKFactory.getMIntegralSDK();
        if(statusType.equals("1")){
            sdk.setConsentStatus(Cocos2dxHelper.getActivity(),1);
        }else{
            sdk.setConsentStatus(Cocos2dxHelper.getActivity(),0);
        }

        printPrivateInfoStatus();
    }

    public static boolean getConsentStatusInfoTypeSelf()
    {
        MIntegralSDK sdk = MIntegralSDKFactory.getMIntegralSDK();
        Log.e("getConsentStatus: ", ""+sdk.getConsentStatus(Cocos2dxHelper.getActivity()));

        return sdk.getConsentStatus(Cocos2dxHelper.getActivity());
    }






    public static void initMintegralSDK(final String appid,final String apikey) {

        FutureTask<String> task = new FutureTask<String>(new Callable<String>() {
            @Override
            public String call() throws Exception {

                initMTGSdk(appid,apikey);

                return "";
            }
        });

        try {
            Cocos2dxHelper.getActivity().runOnUiThread(task);
        } catch (Exception e) {}
    }

    public static void showUserPrivateInfoTips() {

        FutureTask<String> task = new FutureTask<String>(new Callable<String>() {
            @Override
            public String call() throws Exception {

                showUserPrivateInfoTipsSelf();
                return "";
            }
        });

        try {
            Cocos2dxHelper.getActivity().runOnUiThread(task);
        } catch (Exception e) {}
    }

    public static void setUserPrivateInfoType(final String statusKey, final String statusType) {

        FutureTask<String> task = new FutureTask<String>(new Callable<String>() {
            @Override
            public String call() throws Exception {

                setUserPrivateInfoTypeSelf(statusKey,statusType);

                return "";
            }
        });

        try {
            Cocos2dxHelper.getActivity().runOnUiThread(task);
        } catch (Exception e) {}
    }


    public static int userPrivateInfo(final String statusKey) {

        FutureTask<Integer> task = new FutureTask<Integer>(new Callable<Integer>() {
            @Override
            public Integer call() throws Exception {
                return userPrivateInfoSelf(statusKey);
            }
        });

        try {
            //Cocos2dxHelper.getActivity().runOnUiThread(task);
            Integer integer = userPrivateInfoSelf(statusKey); //task.get();
            Log.e("get "+statusKey, ""+integer);
            return integer;
        } catch (Exception e) {return 0;}
    }

    public static void setConsentStatusInfoType(final String statusType) {

        FutureTask<String> task = new FutureTask<String>(new Callable<String>() {
            @Override
            public String call() throws Exception {

                setConsentStatusInfoTypeSelf(statusType);

                return "";
            }
        });

        try {
            Cocos2dxHelper.getActivity().runOnUiThread(task);
        } catch (Exception e) {}
    }

    public static boolean getConsentStatusInfoType() {

        FutureTask<Boolean> task = new FutureTask<Boolean>(new Callable<Boolean>() {
            @Override
            public Boolean call() throws Exception {

                return getConsentStatusInfoTypeSelf();
            }
        });

        try {
            Cocos2dxHelper.getActivity().runOnUiThread(task);
            Boolean bol = task.get();
            return bol;
        } catch (Exception e) {return false;}
    }


    /*
    public static char userPrivateInfo(final String statusKey) {

        FutureTask<String> task = new FutureTask<String>(new Callable<String>() {
            @Override
            public String call() throws Exception {

                //return userPrivateInfoSelf(statusKey);
                return "2";
            }
        });

        try {
            //Cocos2dxHelper.getActivity().runOnUiThread(task);
            //String integer = task.get();
            char a='2';
            return a;
        } catch (Exception e) {
            char b = '1';
            return b;
        }
    }
    */


    //callBack
    private static native void dispatchStatusEventAsync(String code,String level);

}
